
    #include "colors.inc"
//    #include "glass.inc" 
#include "stones.inc"
#include "skies.inc"
#include "transforms.inc" // for Axis_Rotate_Trans(Axis, Angle)
#include "bountiful.inc" // declaration file for this file
#include "woods.inc"
//#include "shapes2.inc"
#include "textures.inc"
//#include "tree_save.inc"
//#include "tree2.inc"
//#include "TOMTREE.inc"
//#include "defaults.inc"
     

                      
            
  camera {
    //location <0, 20, -25>
    //location <5, 5, -5>
    //location <0, 5, -50> //long distance, normal view with no look_at
    location <0, 1, -35> //new normal with no look at 27 Nov2004
    //location <14, 5, 130> //outside main gate
    //look_at <14.5, 0, 111> //outside main gate 
    //look_at <5, 1, 5> //temple only
    //look_at <5, 1, -6> //front of temple
    //look_at <12, 1, -6> //right road intersection
    //look_at 0
    angle 30 //normal angle is 30
    aperture 0.001 //was 0.01
    blur_samples 100
    variance 1/100000
    confidence 0.99
  }
  background { color LightBlue }
  sky_sphere {
    pigment {
      gradient y
      color_map {
        [0.000 0.002 color rgb <0.0, 0.2, 1.0>
                     color rgb <0.0, 0.2, 1.0>]
        [0.002 0.200 color rgb <0.0, 0.1, 0.8>
                     color rgb <0.2, 0.2, 0.3>]
      }

      scale 2
      translate -1
    }
  pigment {
      bozo
      turbulence 0.65
      octaves 6
      omega 0.7
      lambda 2
      color_map {
          [0.0 0.1 color rgb <0.85, 0.85, 0.85>
                   color rgb <0.75, 0.75, 0.75>]
          [0.1 0.5 color rgb <0.75, 0.75, 0.75>
                   color rgbt <1, 1, 1, 1>]
          [0.5 1.0 color rgbt <1, 1, 1, 1>
                   color rgbt <1, 1, 1, 1>]
      }
      scale <0.2, 0.5, 0.2>
    }
    rotate -135*x
  }
  fog {
    distance 150
    color White
    fog_type 2
    fog_offset 25
    fog_alt 1
    turbulence 0.1
    turb_depth 0.2

  }

 /* fog {
    distance 0
    color White
    fog_type 2
    fog_offset 25
    fog_alt 100
    turbulence 0.1
    turb_depth 0.2

  }
  
plane { y, 500
        texture {
            T_Cloud1
            scale 600
        }} */
  
  
  light_source { <100,100,-100>,color Gold + White}
  //Goldenron + white good, plain white ok, gold + white nice
  //light_source { <-300, 300, 150> White }
 //global_settings { ambient_light rgb<1, 1, 1> }
// light_source {
 //   <2, 10, -3>
 //   color White
 //   area_light <5, 0, 0>, <0, 0, 5>, 5, 5
 //   adaptive 1
 //   jitter
 // } 

//#declare Brick_Texture = texture {
  //  pigment {
    //    brick //Gray35, Gray45
  //  }
  //  normal {
    //    brick //0.01
   // }
  //  finish {
  //      crand 0.003
  //      diffuse 0.6 ambient 0.20
 //   }
  //  scale <-1, -1, -0.5>
    //translate <0.25, 0.30, 0.25> 
//}

//object {S_90torus pigment{Dcolor} translate y*5}     

// color DarkBrown is good, Tan is ok
// X = width
// Y = height
// Z = depth
#declare IndexX = 0.0; //start x
#declare IndexY = -2.0; //start yyyyyyyyyyyyyyyyyyyy -1
#declare IndexZ = -1.0; //start z
#declare IndexA = 10.0; //end x bottom
#declare IndexB = 3.0; //end y
#declare IndexC = 10.0; //end z bottom
#declare IndexX2 = 4.0; //top left x
#declare IndexZ2 = 3.0; //top left z
#declare IndexX3 = 6.0; //top right x
#declare IndexZ3 = 6.0; //top right z
//#while(IndexY <= 2)
      
      
      // temple base
      
      //     pigment { Gray35 } texture {Dtexture} 
             //normal { bumps 0.4 scale .1 }
     
      mesh{
      //front
      triangle{ <IndexX, IndexY, IndexZ>, <IndexA / 2, IndexY, IndexZ>, <IndexX2, IndexB, IndexZ2>} //lower left - lower left, lower right, upper middle
      triangle{ <IndexA / 2, IndexY, IndexZ>, <IndexA, IndexY, IndexZ>, <IndexX3, IndexB, IndexZ2> } //lower right - lower left, lower right, upper middle
      triangle{ <IndexA / 2, IndexY, IndexZ>, <IndexX2, IndexB, IndexZ2>, <IndexX3, IndexB, IndexZ2>} //upper middle - lower middle, upper left, upper right
      
      //left
      triangle{ <IndexX, IndexY, IndexC>, <IndexX, IndexY, IndexC / 2>, <IndexX2, IndexB, IndexZ3> } //lower left - lower left, lower right, upper middle
      triangle{ <IndexX, IndexY, IndexC / 2>, <IndexX, IndexY, IndexZ>, <IndexX2, IndexB, IndexZ2> } //lower right - lower left, lower right, upper middle
      triangle{ <IndexX, IndexY, IndexC / 2>, <IndexX2, IndexB, IndexZ3>, <IndexX2, IndexB, IndexZ2> } //upper middle - lower middle, upper left, upper right
      
      //right
      triangle{ <IndexA, IndexY, IndexC>, <IndexA, IndexY, IndexC / 2>, <IndexX3, IndexB, IndexZ3> } //lower left - lower left, lower right, upper middle
      triangle{ <IndexA, IndexY, IndexC / 2>, <IndexA, IndexY, IndexZ>, <IndexX3, IndexB, IndexZ2> } //lower right - lower left, lower right, upper middle
      triangle{ <IndexA, IndexY, IndexC / 2>, <IndexX3, IndexB, IndexZ3>, <IndexX3, IndexB, IndexZ2> } //upper middle - lower middle, upper left, upper right
      
      //rear
      triangle{ <IndexX, IndexY, IndexC>, <IndexA / 2, IndexY, IndexC>, <IndexX2, IndexB, IndexZ3> } //lower left - lower left, lower right, upper middle
      triangle{ <IndexA / 2, IndexY, IndexC>, <IndexA, IndexY, IndexC>, <IndexX3, IndexB, IndexZ3> } //lower right - lower left, lower right, upper middle
      triangle{ <IndexA / 2, IndexY, IndexC>, <IndexX2, IndexB, IndexZ3>, <IndexX3, IndexB, IndexZ3> } //upper middle - lower middle, upper left, upper right
      
      //top
      triangle{ <IndexX2, IndexB, IndexZ2>, <IndexX2, IndexB, IndexZ3>, <IndexX3, IndexB, IndexZ3> } //left rear - lower left, upper left, upper right
      triangle{ <IndexX2, IndexB, IndexZ2>, <IndexX3, IndexB, IndexZ2>, <IndexX3, IndexB, IndexZ3> } //right front - lower left, lower right, upper right
      
      
      
      //pigment { Gray30 } texture {Dtexture} //normal { bumps 0.6 scale .1 }
      pigment { color Dcolor } normal {bumps 0.4 scale .01}
      }
     
      

        
 
 #declare IndexY = IndexB;
 #declare IndexA = 4.25;
 #declare IndexB = 5.75;
 #declare IndexX = IndexA;
 #declare IndexZ = IndexA;
 //#end

  box {<IndexA, IndexY + 1, IndexA>,  // Near lower left corner              //roof
            <IndexB, IndexY + 1.25, IndexB>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01} } 
            
box {<IndexA, IndexY, IndexA>,  // lower left pillar supporting roof         PILLARS     ***********
            <IndexA + 0.25, IndexY + 0.49, IndexA + 0.25>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01}}
            
box {<IndexA, IndexY + 0.51, IndexA>,  // lower left pillar supporting roof         
            <IndexA + 0.25, IndexY + 0.98, IndexA + 0.25>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01}}            
            
 box {<IndexA + 0.02, IndexY, IndexA + 0.02>,  // lower left pillar supporting roof
            <IndexA + 0.23, IndexY + 1, IndexA + 0.23>   // Far upper right corner
            pigment { color Dcolor } texture {Dtexture}}           
            
 box {<IndexB - 0.25, IndexY, IndexA>,  // lower right pillar       ****************
            <IndexB, IndexY + 0.49, IndexA + 0.25>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01}}
            
box {<IndexB - 0.25, IndexY + 0.51, IndexA>,  // lower right pillar
            <IndexB, IndexY + 0.98, IndexA + 0.25>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01}}            
            
box {<IndexB - 0.23, IndexY, IndexA + 0.02>,  // lower right pillar
            <IndexB -0.02, IndexY + 1, IndexA + 0.23>   // Far upper right corner
            pigment { color Dcolor } texture {Dtexture}}            
            
box {<IndexA, IndexY, IndexB - 0.25>,  // upper left pillar    ********************
            <IndexA + 0.25, IndexY + 0.49, IndexB>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01}} 
            
box {<IndexA, IndexY + 0.51, IndexB - 0.25>,  // upper left pillar
            <IndexA + 0.25, IndexY + 0.98, IndexB>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01}}                 
            
box {<IndexA + 0.02, IndexY, IndexB - 0.23>,  // upper left pillar
            <IndexA + 0.25, IndexY + 1, IndexB>   // Far upper right corner
            pigment { color Dcolor } texture {Dtexture}}            
            
box {<IndexB - 0.25, IndexY, IndexB - 0.25>,  // Near lower left corner, upper right pillar *********
            <IndexB, IndexY + 0.49, IndexB>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01}}   
            
box {<IndexB - 0.25, IndexY + 0.51, IndexB - 0.25>,  // Near lower left corner, upper right pillar
            <IndexB, IndexY + 0.98, IndexB>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01}}             
            
box {<IndexB - 0.23, IndexY, IndexB - 0.23>,  // Near lower left corner, upper right pillar
            <IndexB - 0.02, IndexY + 1, IndexB - 0.02>   // Far upper right corner
            pigment { color Dcolor } texture {Dtexture}}              
            
            #declare V1 = <5, 0, -2>;
            #declare V2 = <5, IndexY, IndexA - 2.9>;
            #declare Dist=vlength(V1-V2);
            
   
//#declare IndexX = 0.0;
#declare IndexY = 3;
#declare IndexZ = 3;
#declare Depth = 1;
//#declare IndexA = 0;
#while(IndexY >= -2) //stairs, start at top, end at bottom
   //internal boxes
   box {<4.5, IndexY - 0.08, IndexZ - 0.08>,  // Near lower left corner, upper internal box
            <5.4, IndexY - 0.01, IndexZ + Depth>//-0.01>   // Far upper right corner
            pigment { color Dcolor } texture {Dtexture}}
    
    box {<4.5, IndexY - 0.18, IndexZ - 0.18>,  // Near lower left corner, lower internal box
            <5.4, IndexY - 0.11, IndexZ + Depth>//-0.11>   // Far upper right corner
            pigment { color Dcolor } texture {Dtexture}}
    
    #declare IndexX = 5.4;  //upper external boxes X start in right side
     
    //#declare IndexA = even (IndexY);
    //#if (IndexA) = 1)
    box {<IndexX - 0.135, IndexY - 0.1, IndexZ - 0.1>,  // Near lower left corner, upper right external box
            <IndexX, IndexY, IndexZ + Depth> // Didn't have depth, Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01} }
    #declare IndexX = IndexX - 0.145;
    
    #while(IndexX >= 4.75) //end on X left side
      box {<IndexX - 0.235, IndexY - 0.1, IndexZ - 0.1>,  // Near lower left corner, right to left external boxes
            <IndexX, IndexY, IndexZ + Depth>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01} }
    #declare IndexX = IndexX - .245;
    #end
    box {<IndexX - 0.03, IndexY - 0.1, IndexZ - 0.1>,  // Near lower left corner, upper left external box
            <IndexX, IndexY, IndexZ + Depth>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01} }
   
   
   // #else
    #declare IndexX = 4.5; //lower external boxes X start on left side
    box {<IndexX, IndexY - 0.2, IndexZ - 0.2>,  // Near lower left corner, lower left external box
            <IndexX + 0.135, IndexY - 0.1, IndexZ + Depth> //- 0.1>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01} }
    #declare IndexX = IndexX + 0.145;         
    //#declare IndexX = 4.5;
    #while(IndexX <= 5.25) //end on X right side
     box {<IndexX, IndexY - 0.2, IndexZ - 0.2>,  // Near lower left corner, left to right external boxes
            <IndexX + .235, IndexY - 0.1, IndexZ + Depth>//- 0.1>   // Far upper right corner
            pigment { color Dcolor } normal {bumps 0.4 scale .01} }
    #declare IndexX = IndexX + .245;
    #end  
    box {<IndexX, IndexY - 0.2, IndexZ - 0.2>,  // Near lower left corner, lower right external box
            <IndexX + 0.03, IndexY - 0.1, IndexZ + Depth>//- 0.1>   // Far upper right corner
           pigment { color Dcolor } normal {bumps 0.4 scale .01} }

#declare IndexZ = IndexZ - 0.2;
#declare IndexY = IndexY - 0.2;
#end //of the entire temple
    



//pave the city
//Road(<Where>, Length, Width, Angle) length=depth, width=left to right
    #declare IndexY=-2.95; //-1.95
    Road(<-16, IndexY, -22>, 32, 32, 0)  //lowest
    Road(<-23, IndexY, 10>, 20, 44, 0)   //middle1
    Road(<-30, IndexY, 30>, 20, 57, 0)   //middle2
    Road(<-36, IndexY, 50>, 20, 70, 0)   //middle3
    Road(<-42, IndexY, 70>, 20, 80, 0)   //middle4
    Road(<-50, IndexY, 90>, 20, 95, 0)   //highest and last
    
    
/*intersection{
      plane { <0, 5.25, 0>, -0.1 } 
    cylinder{                                         
      //<Base_Point>, <Cap_Point>, Radius 
        <0, -2, 0>, <0, 5, 0>, 110
            }
	    //Pavement(<Where>, Length, Width, Angle)*/
//    Pavement(<-15, -1.95, -15>, 125, 125, 0)
//  pigment { color Dcolor } texture {Dtexture}
/*pigment {
    brick
    color Gray45 color Gray35
    rotate -90*x
    scale .01
  }
   normal {
    brick 0.4
    rotate -90*x
    scale .01
  }*/
//   } //end paving the city
	    

//start of trees
//scale >1 expand, <1 shrink
#declare Fruity=texture{normal{bump_map {png "popcorn1.png"} } pigment{image_map {png "popcorn1.png"} } scale 0.2}

//#declare IndexX = 1;
#declare IndexY = -1.95; //-0.95
//#declare IndexZ = -10;
#declare BaseLen=0.1;
#declare Tip=2;
#declare LeafShape=3;
#declare LeafTexture=0;
#declare FruitShape=2; //0=default 2=large sphere, 5=trible berry
#declare FruitTexture=1; //was 5 for white fruit
#declare TREE=#include "trees.inc" //nicer to have #include within each while loop instead of TREE below, to create indivual trees
// this only creates one tree and copies it. Easier on memory though.

#declare BaseLen=0.1;
#declare IndexA = 1;
#while(IndexA <= 360)
object {TREE translate <0, IndexY, 20> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
// rotate <0, IndexY, 0>
//#declare IndexX = IndexX + 10;
//#declare IndexY = IndexY + 25;
//#declare IndexZ = IndexZ + 1;
#declare IndexA = IndexA + 9;
#end

/*
#declare BaseLen=0.1;
#declare IndexA = 1;
//#declare IndexY = -0.95; //-0.95
#while(IndexA <= 360)
//object {TREE translate <0, IndexY, 25> scale 2 Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
object {TREE translate <0, IndexY, 30> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
// rotate <0, IndexY, 0>
//#declare IndexX = IndexX + 10;
//#declare IndexY = IndexY + 25;
//#declare IndexZ = IndexZ + 1;
#declare IndexA = IndexA + 7; //was 5
#end
*/


// from center to left side Z=40
#declare BaseLen=0.1;
#declare IndexA = 1; //1 started right in front
#while(IndexA <= 33) //goes in a counter clockwise direction, 35 goes just off screen on the left
//object {TREE translate <0, IndexY, 30> scale 2 Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
object {TREE translate <0, IndexY, 40> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
// rotate <0, IndexY, 0>
//#declare IndexX = IndexX + 10;
//#declare IndexY = IndexY + 25;
//#declare IndexZ = IndexZ + 1;
#declare IndexA = IndexA + 4; //was 2
#end

// from right to center Z=40
#declare BaseLen=0.1;
#declare IndexA = 330; //1 started right in front
#while(IndexA <= 358) //goes in a counter clockwise direction, 35 goes just off screen on the left
//object {TREE translate <0, IndexY, 30> scale 2 Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
object {TREE translate <0, IndexY, 40> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
// rotate <0, IndexY, 0>
//#declare IndexX = IndexX + 10;
//#declare IndexY = IndexY + 25;
//#declare IndexZ = IndexZ + 1;
#declare IndexA = IndexA + 4; //was 2
#end

//  multible trees here to enhance readablity
// from center to left
#declare BaseLen=0.1;
#declare IndexA = 1; 
#while(IndexA <= 33)
//object {TREE translate <0, IndexY, 35> scale 2 Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
//object {TREE translate <0, IndexY, 50> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
object {TREE translate <0, IndexY, 60> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)} //lack of memory
//object {TREE translate <0, IndexY, 70> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
//object {TREE translate <0, IndexY, 80> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)} //lack of memory
object {TREE translate <0, IndexY, 90> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
// rotate <0, IndexY, 0>
//#declare IndexX = IndexX + 10;
//#declare IndexY = IndexY + 25;
//#declare IndexZ = IndexZ + 1;
#declare IndexA = IndexA + 3; //was 2
#end

// from right to center
#declare BaseLen=0.1;
#declare IndexA = 330; 
#while(IndexA <= 358)
//object {TREE translate <0, IndexY, 35> scale 2 Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
//object {TREE translate <0, IndexY, 50> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
object {TREE translate <0, IndexY, 60> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)} //lack of memory
//object {TREE translate <0, IndexY, 70> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
//object {TREE translate <0, IndexY, 80> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)} //lack of memory
object {TREE translate <0, IndexY, 90> Axis_Rotate_Trans(<0, -1.5, 0>, IndexA)}
// rotate <0, IndexY, 0>
//#declare IndexX = IndexX + 10;
//#declare IndexY = IndexY + 25;
//#declare IndexZ = IndexZ + 1;
#declare IndexA = IndexA + 3; //was 2
#end



//end of trees
                                    
 union{
  //difference{ //used to make a moat around the city
  plane { <0, 5, 0>, -2}   //ground -1
  //torus {111, 3 translate y*-3}   //moat     
  //  }
  
 difference{ //used to make gates in the torus wall
 torus {100, 3 translate y*-2}   // city wall, not sure what to do about the wall
 box{<13.5, -3, 30>, <15.5, 10, 200>} //main gate
 }
 pigment {color DarkTan} normal { bumps 0.4 scale .1 }
  } //end plane union
  
//  plane {<0, 1, 0>, -1.1 pigment {rgbf <0, 0, 1, 1>} normal {waves} finish { diffuse 0.5 reflection { 0.03, 1 }conserve_energy}}

 //Axis_Rotate_Trans(Axis, Angle)
#declare IndexA = 0;
#while (IndexA <= 7.6)
 object {DStick translate <0, 0.7, 100> Axis_Rotate_Trans(<0, 3, 0>, IndexA)}
 object {DStick rotate x*45 translate <0, 0.7, 100> Axis_Rotate_Trans(<0, 3, 0>, IndexA + 0.075)}
 #declare IndexA = IndexA + 0.15;
 #end
 //WAS INDEXa + .15, INDEXA + INDEXA + .3
 //ok at /1 and .2

#declare IndexA = 9;
#while (IndexA <= 25)
 object {DStick translate <0, 0.7, 100> Axis_Rotate_Trans(<0, 3, 0>, IndexA)}
 object {DStick rotate x*45 translate <0, 0.7, 100> Axis_Rotate_Trans(<0, 3, 0>, IndexA + 0.075)}
 #declare IndexA = IndexA + 0.15;
 #end

 #declare IndexA = 335;
#while (IndexA <= 360)
 object {DStick translate <0, 0.7, 100> Axis_Rotate_Trans(<0, 3, 0>, IndexA)}
 object {DStick rotate x*45 translate <0, 0.7, 100> Axis_Rotate_Trans(<0, 3, 0>, IndexA + 0.075)}
 #declare IndexA = IndexA + 0.15;
 #end   